PAbstractList Class Reference

This class is a collection of objects which are descendents of the `PObject` class. More...

`#include <lists.h>`

Inheritance diagram for PAbstractList:

## Public Member Functions

virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two lists. More...
Construction
PINLINE | PAbstractList ()
| Create a new, empty, list. More...
Overrides from class PContainer
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for lists. More...
Overrides from class PCollection
virtual PINDEX | Append (PObject *obj)
| Append a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Insert a new object immediately before the specified object. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified ordinal index. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual PBoolean | ReplaceAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Types

typedef PListElement | Element

## Protected Member Functions

PINLINE PObject & | GetReferenceAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
PBoolean | SetCurrent (PINDEX index, PListElement *&lastElement) const
| Move the internal "cursor" to the index position specified. More...
PObject * | RemoveElement (PListElement *element)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PListInfo * | info
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...

## Detailed Description

This class is a collection of objects which are descendents of the `PObject` class.

It is implemeted as a doubly linked list.

The implementation of a list allows very fast inserting and deleting of objects in the collection, but has severe penalties for random access. All object access should be done sequentially to avoid these speed penalties.

The class remembers the last accessed element. This state information is used to optimise access by the "virtual array" model of collections. If access via ordinal index is made sequentially there is little overhead.

The PAbstractList class would very rarely be descended from directly by the user. The `PDECLARE_LIST` and `PLIST` macros would normally be used to create descendent classes. They will instantiate the template based on `PList` or directly declare and define the class (using inline functions) if templates are not being used.

The `PList` class or `PDECLARE_LIST` macro will define the correctly typed operators for subscript access (operator[]).

## Member Typedef Documentation

## Element

typedef PListElement PAbstractList::Element

protected

## Constructor & Destructor Documentation

## PAbstractList()

PINLINE PAbstractList::PAbstractList | ( |  | ) |

Create a new, empty, list.

Note that by default, objects placed into the list will be deleted when removed or when all references to the list are destroyed.

## Member Function Documentation

## Append()

virtual PINDEX PAbstractList::Append | ( | PObject * | obj | ) |

virtual

Append a new object to the collection.

This places a new link at the "tail" of the list.

Returns
  index of the newly added object.

Parameters

  obj | New object to place into the collection.

Implements PCollection.

Referenced by PQueue< PXML >::Enqueue().

## Compare()

virtual Comparison PAbstractList::Compare | ( | const PObject & | obj | ) | const

virtual

Get the relative rank of the two lists.

The following algorithm is employed for the comparison:

- `EqualTo` if the two lists are identical in length and each objects values, not pointer, are equal.

- `LessThan` if the instances object value at an ordinal position is less than the corresponding objects value in the `obj` parameters list.

This is also returned if all objects are equal and the instances list length is less than the `obj` parameters list length.

- `GreaterThan` if the instances object value at an ordinal position is greater than the corresponding objects value in the `obj` parameters list.

This is also returned if all objects are equal and the instances list length is greater than the `obj` parameters list length.

Returns
  comparison of the two objects, `EqualTo` for same, `LessThan` for `obj` logically less than the object and `GreaterThan` for `obj` logically greater than the object.

Parameters

  obj | Object being compared to

Reimplemented from PObject.

## GetAt()

virtual PObject* PAbstractList::GetAt | ( | PINDEX | index | ) | const

virtual

Get the object at the specified ordinal position.

If the index was greater than the size of the collection then NULL is returned.

The object accessed in this way is remembered by the class and further access will be fast. Access to elements one either side of that saved element, and the head and tail of the list, will always be fast.

Returns
  pointer to object at the specified index.

Parameters

  index | Index position in the collection of the object.

Implements PCollection.

## GetObjectsIndex()

virtual PINDEX PAbstractList::GetObjectsIndex | ( | const PObject * | obj | ) | const

virtual

Search the collection for the specific instance of the object.

The object pointers are compared, not the values. A simple linear search from "head" of the list is performed.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Parameters

  obj | Object to find.

Implements PCollection.

## GetReferenceAt()

PINLINE PObject& PAbstractList::GetReferenceAt | ( | PINDEX | index | ) | const

protected

Get the object at the specified ordinal position.

If the index was greater than the size of the collection then this asserts.

The object accessed in this way is remembered by the class and further access will be fast. Access to elements one either side of that saved element, and the head and tail of the list, will always be fast.

Returns
  reference to object at the specified index.

Parameters

  index | Ordinal index of the list element to set as current.

## GetValuesIndex()

virtual PINDEX PAbstractList::GetValuesIndex | ( | const PObject & | obj | ) | const

virtual

Search the collection for the specified value of the object.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. A simple linear search from "head" of the list is performed.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Parameters

  obj | Object to find value of.

Implements PCollection.

## Insert()

virtual PINDEX PAbstractList::Insert | ( | const PObject & | before,
|  | PObject * | obj
| ) |  |

virtual

Insert a new object immediately before the specified object.

If the object to insert before is not in the collection then the equivalent of the `Append()` function is performed.

Note that the object values are compared for the search of the `before` parameter, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function.

Returns
  index of the newly inserted object.

Parameters

  before | Object value to insert before.
  obj | New object to place into the collection.

Implements PCollection.

## InsertAt()

virtual PINDEX PAbstractList::InsertAt | ( | PINDEX | index,
|  | PObject * | obj
| ) |  |

virtual

Insert a new object at the specified ordinal index.

If the index is greater than the number of objects in the collection then the equivalent of the `Append()` function is performed.

Returns
  index of the newly inserted object.

Parameters

  index | Index position in collection to place the object.
  obj | New object to place into the collection.

Implements PCollection.

Referenced by PStack< T >::Push().

## Remove()

virtual PBoolean PAbstractList::Remove | ( | const PObject * | obj | ) |

virtual

Remove the object from the collection.

If the AllowDeleteObjects option is set then the object is also deleted.

Returns
  true if the object was in the collection.

Parameters

  obj | Existing object to remove from the collection.

Implements PCollection.

## RemoveAt()

virtual PObject* PAbstractList::RemoveAt | ( | PINDEX | index | ) |

virtual

Remove the object at the specified ordinal index from the collection.

If the AllowDeleteObjects option is set then the object is also deleted.

Note if the index is beyond the size of the collection then the function will assert.

Returns
  pointer to the object being removed, or NULL if it was deleted.

Parameters

  index | Index position in collection to place the object.

Implements PCollection.

Referenced by PQueue< PXML >::Dequeue(), and PStack< T >::Pop().

## RemoveElement()

PObject* PAbstractList::RemoveElement | ( | PListElement * | element | ) |

protected

## ReplaceAt()

virtual PBoolean PAbstractList::ReplaceAt | ( | PINDEX | index,
|  | PObject * | val
| ) |  |

virtual

Set the object at the specified ordinal position to the new value.

This will overwrite the existing entry. If the AllowDeleteObjects option is set then the old object is also deleted.

Note if the index is beyond the size of the collection then the function will assert.

Returns
  true if the object was successfully replaced.

Parameters

  index | Index position in collection to set.
  val | New value to place into the collection.

## SetAt()

virtual PBoolean PAbstractList::SetAt | ( | PINDEX | index,
|  | PObject * | val
| ) |  |

virtual

Set the object at the specified ordinal position to the new value.

This will overwrite the existing entry. This method will NOT delete the old object independently of the AllowDeleteObjects option. Use `ReplaceAt()` instead.

Note if the index is beyond the size of the collection then the function will assert.

Returns
  true if the object was successfully added.

Parameters

  index | Index position in collection to set.
  val | New value to place into the collection.

Implements PCollection.

## SetCurrent()

PBoolean PAbstractList::SetCurrent | ( | PINDEX | index,
|  | PListElement *& | lastElement
| ) |  | const

protected

Move the internal "cursor" to the index position specified.

This function will optimise the sequential move taking into account the previous current position and the position at the head and tail of the list. Whichever of these three points is closes is used as the starting point for a sequential move to the required index.

Returns
  true if the index could be set as the current element.

Parameters

  index | Ordinal index of the list element to set as current.
  lastElement | pointer to final element

## SetSize()

virtual PBoolean PAbstractList::SetSize | ( | PINDEX | newSize | ) |

virtual

This function is meaningless for lists.

The size of the collection is determined by the addition and removal of objects. The size cannot be set in any other way.

Returns
  Always true.

Parameters

  newSize | New size for the list, this is ignored.

Implements PContainer.

## Member Data Documentation

## info

PListInfo* PAbstractList::info

protected

The documentation for this class was generated from the following file:

- lists.h